package com.ruoyi.system.mapper;

import java.util.List;

import com.ruoyi.system.domain.vo.UrYearValidDataVo;
import org.apache.ibatis.annotations.Param;
import com.ruoyi.system.domain.UrYearValidData;

/**
 * 专利有效按年统计结果Mapper接口
 * 
 * @author dm
 * @date 2023-02-12
 */
public interface UrYearValidDataMapper 
{
    /**
     * 查询专利有效按年统计结果
     * 
     * @param id 专利有效按年统计结果主键
     * @return 专利有效按年统计结果
     */
    public UrYearValidData selectUrYearValidDataById(Long id);

    /**
     * 查询专利有效按年统计结果列表
     * 
     * @param urYearValidData 专利有效按年统计结果
     * @return 专利有效按年统计结果集合
     */
    public List<UrYearValidData> selectUrYearValidDataList(UrYearValidDataVo urYearValidData);

    /**
     * 新增专利有效按年统计结果
     * 
     * @param urYearValidData 专利有效按年统计结果
     * @return 结果
     */
    public int insertUrYearValidData(UrYearValidData urYearValidData);

    /**
     * 修改专利有效按年统计结果
     * 
     * @param urYearValidData 专利有效按年统计结果
     * @return 结果
     */
    public int updateUrYearValidData(UrYearValidData urYearValidData);

    /**
     * 删除专利有效按年统计结果
     * 
     * @param id 专利有效按年统计结果主键
     * @return 结果
     */
    public int deleteUrYearValidDataById(Long id);

    /**
     * 批量删除专利有效按年统计结果
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteUrYearValidDataByIds(Long[] ids);
    /**
     * 删除专利有效按年统计结果
     *
     * @param id 专利有效按年统计结果ID
     * @return 结果
     */
    public int setDeleteById(@Param("id") Long id, @Param("operId") Long operId, @Param("operName") String operName);

    /**
     * 批量删除专利有效按年统计结果---逻辑删除
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int setDeleteByIds(@Param("ids") Long[] ids, @Param("operId") Long operId, @Param("operName") String operName);

    /**
     * 获取有效概览左侧表头列表
     * @return
     */
    public List<UrYearValidData> selectUrLeftList();

    /**
     * 查询云南省专利有效按年统计结果列表
     *
     * @param urYearValidData 专利有效按年统计结果
     * @return 云南省专利有效按年统计结果集合
     */
    public List<UrYearValidData> selectUrYearValidDataProvinceList(UrYearValidDataVo urYearValidData);

    /**
     * 查询有效概览里需要的最新有效数据所在年
     * @return
     */
    public UrYearValidData selectYearList();

}
